﻿Imports System.Data.SqlClient       ' para SQLExpress           Letras clave para Buscar-Reemplazar : Sql
Imports MySql.Data.MySqlClient      ' para MySql                Letras clave para Buscar-Reemplazar : MySql
Imports System.Data.OleDb           ' para Access               Letras clave para Buscar-Reemplazar : OleDb
'Imports System.Data.Odbc            ' para un controlador ODBC  Letras clave para Buscar-Reemplazar : Odbc
'Imports System.Data.OracleClient    ' a descargar de Microsoft  Letras clave para Buscar-Reemplazar : Oracle


Public Class FGestionExistencias

    Dim CR As Char = Char.ConvertFromUtf32(13) ' Solo por la estética de los mensajes :D)))


    Dim TestigoDBAbierta As Boolean = False ' Si el DB está abierto, ciérrelo dejando. La salida es un poco diferente. 
    ' cf. BDejar_Click y FGestionExistencias_FormClosing

    Dim TestigoNuevoIdentificador As Boolean = False ' Se convierte en True cuando se crea un identificador (esto sucede al agregar datos) y vuelve a ser False
    ' cuando se finalice o se abandone la añadido. Cabe señalar que la añadido de los datos requiere 2 clics en BAgregar, 
    ' un primero vez para crear un registro vacío para llenar, y un segundo vez para causar registro físico o abandono.

    Dim LecturaIterativaPermitida As Boolean = True ' Al ingresar al procedimiente de Tratamiento de datos, debe ser imposible
    ' todavía escanear registros car Tratamientos_Click trata el registro actual. Por tanto, es necesario finalizar la operación iniciada o
    ' renuncia para que puedas consultar de nuevo.

    Dim MiConexion As OleDbConnection  ' ...
    Dim MiComando As New OleDbCommand   ' ...
    Dim FraseDeConexion As String   ' ...

    Dim MisExistencias As New DataSet  'Los registros en memoria. Carga los componentes  visual y se expone instantáneamente a todos 
    ' modificaciónes realizados en los textos mostrados. Sin embargo, estos modificaciones están en la memoria y no afectan la base de datos real.
    ' Por lo tanto, el algoritmo implementado en este programa provoca la acción en la base de datos real cuando es necesario, es decir por procedimientes
    ' RegistrarAgregado(Idx), RegistrarModificacion(Idx), RegistrarEliminacion(Idx) conducido por Tratamientos_Click(). La búsqueda desde el DataSet usa el modo "Desconectado"
    ' mientras que los cambios en tiempo real utilizan el modo "Conectado".

    Private Sub BDejar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BDejar.Click
        CerrarDB()  ' ...
        Me.Close()  ' ...
    End Sub

    Private Sub FGestionExistencias_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If TestigoDBAbierta Then     ' entonces, tienes que cerrarlo : BDejar_Click hace eso.
            BDejar_Click(Me, Nothing)
        End If
    End Sub

    Private Sub FGestionExistencias_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        AbrirDB() ' ...
    End Sub

    Private Sub CerrarDB()
        TestigoDBAbierta = False ' ya que está cerrado ...

        MiComando.Dispose()    ' Cada instancia creada con el operadorr New ebe cerrarse con Dispose o Close, o 
        MiConexion.Close()     ' ambos cuando sea posible. El propósito de estas pequeñas tareas es permitir que   
        MiConexion.Dispose()   ' el sistema libere la memoria ocupada por estos objetos.
        MisExistencias.Dispose()
    End Sub

    Private Sub AbrirDB()

        '' *** Nombre del base de datos, nombre del servidor y frase de conexión ***
        ' Los dos variables son solo usado aqui, en la frase de conexión, pero tratado por separado para modicación fácil

        ' Para SQLExpress
        'Dim NombreBDCompleto As String = "D:\Tmp\MisExistencias\DBExistencias.mdf"
        'Dim NombreServidor As String = "SCX_2018\SQLEXPRESS"
        'FraseDeConexion = "Data Source=" & NombreServidor & "; AttachDbFilename=" & NombreBDCompleto & ";Integrated Security=True"

        '' Para MySQL
        'Dim NombreBDCompleto As String = "DBExistencias"
        'Dim NombreServidor As String = "127.0.0.1"
        'FraseDeConexion = "SERVER=" & NombreServidor & ";UID='root';DATABASE=" & NombreBDCompleto & ";Password=''"

        '' Para Access 2003
        Dim NombreBDCompleto As String = "D:\Tmp\MisExistencias\DBExistencias.mdb"
        Dim NombreServidor As String = "Microsoft.Jet.OLEDB.4.0"
        FraseDeConexion = "Provider=" & NombreServidor & ";Data Source=" & NombreBDCompleto

        MiConexion = AbrirConexion(FraseDeConexion) ' Códigos, incluso explotados una vez (en este programa) se ponen en procedimiente.
        ' La razón principal es que en una aplicación un poco más compleja, se reutilizan varias veces. Por otro lado,
        ' el aislamiento (en comentarios) de estos códigos permite ignorarlos (temporalmente) al desarrollar nuevos procedimientes y aligerar su código.
        ' AbrirDB() contiene 6 líneas de códigos, perfectamente comprensibles. Si todos los códigos de los procedimientos convocados fueran reproducidos
        ' aquí, AbrirDB () contendría más de 15 líneas de código, mucho menos legibles.

        CargarDatos() ' ...
        MostrarDatos() ' ...

        TestigoDBAbierta = True     ' ya que está abierto ...
    End Sub

    ' Tener acceso efectivo a los datos. En el modo conectado utilizado en las actualizaciones en tiempo real, la conexión debe estar abierta,
    ' en otros casos, basta con que esté definido, un DataApter procede a la apertura real.
    Private Function AbrirConexion(ByVal FraseDeConexionCompleta As String, Optional ByVal Abrir As Boolean = True) As OleDbConnection
        Dim UnaConexion As New OleDbConnection
        UnaConexion.ConnectionString = FraseDeConexionCompleta
        If Abrir Then UnaConexion.Open() ' La apertura efectiva no es necesaria para usar un DataAdapter
        Return UnaConexion
    End Function

    ' Utilice la conexión para leer los datos de la base de datos según la consulta (Sql) pasada por parámetro y devolver un DataTable para el DataSet en la memoria
    Private Function CrearUnaTabla(ByRef UnaConexion As OleDbConnection, ByVal Seleccion As String) As DataTable
        Dim UnaTabla As New DataTable
        Dim UnaConexionTmp As New OleDbDataAdapter(Seleccion, UnaConexion)
        UnaConexionTmp.FillSchema(UnaTabla, SchemaType.Source) ' Algunos sistemas no permiten FillSchema, entonce aislar la frase
        UnaConexionTmp.Fill(UnaTabla)
        Return UnaTabla
    End Function

    ' Especialmente para el modo conectado utilizado en las actualizaciones en tiempo real, es necesario obtener el objeto "Command" apropiado.
    Private Function CrearComando(ByRef UnaConexion As OleDbConnection, ByVal FraseSql As String) As OleDbCommand
        Dim UnaComando As New OleDbCommand
        UnaComando = UnaConexion.CreateCommand
        UnaComando.CommandType = CommandType.Text
        UnaComando.CommandText = FraseSql
        Return UnaComando
    End Function

    ' La conexión establecida en la apertura de la base de datos se utiliza para buscar las tablas por el DataSet en la memoria
    Private Sub CargarDatos()
        ' Cargar las tablas en el DataSet
        MisExistencias.Tables.Add(CrearUnaTabla(MiConexion, "SELECT * FROM TLosProductos"))
        ' .............
        ' MisExistencias.Tables.Add(CrearUnaTabla(MiConexion, "SELECT * FROM ..............."))
        ' .............
    End Sub

    ' La gestión de  Identificador  por el programador (en lugar de un AutoIncrement del DBMS)  permite mucho más que a continuación
    ' En particular, es posible recuperar los agujeros dejados por las eliminaciones. Aquí solo encontramos
    ' el lmás grande Identificador y incrementarlo para obtener el nuevo.
    Private Function CrearIdentificador() As Integer
        Dim NuevoIdentificador As Integer = 0
        If MisExistencias.Tables("TLosProductos").Rows.Count > 0 Then
            For Each R As DataRow In MisExistencias.Tables("TLosProductos").Rows
                If R.RowState <> DataRowState.Deleted Then
                    If R.Item("Identificador") > NuevoIdentificador Then NuevoIdentificador = R.Item("Identificador")
                End If
            Next
        End If
        Return NuevoIdentificador + 1
    End Function

    ' Es suficiente aquí para enlacar los componentes visuales a los datos que deben mostrar. Programación "manual" de estos enlaces
    ' permite romperlos cuando es conveniente según la necesidad del momento y reconstruirlos después.
    ' En este programa, MostrarDatos define los enlaces y LiberarBindings() los rompe.
    Private Sub MostrarDatos()
        If MisExistencias.Tables("TLosProductos").Rows.Count < 1 Then      ' No es necesario si no hay registro.
            Exit Sub
        End If

        ' Algunos componentes tienen uno  DataSource, y aquellos que solo pueden presentar un campo de registro tienen
        ' uno DisplayMember. Este es el caso de un ListBox, entonce :
        ' LaListBox.DataSource = MisExistencias.Tables("TLosProductos") ' es ejemplo
        ' LaListBox.DisplayMember = "Producto" ' es ejemplo

        DGVExistencias.DataSource = MisExistencias.Tables("TLosProductos")   ' Algunos componentes, como DtadGridView, tienen DataSource

        DGVExistencias.Columns("Identificador").ReadOnly = True              ' No modificación manual del Identificador

        ' Algunos componentes no tienen DataSource pero tienen une colección de Bindings en los que
        ' agregar el nombre de la propiedad afectada, el DataSet quien produce los datos, y el campo a afectar a la propiedad
        ' Ejempl0 : TProducto.DataBindings.Add("Text", MisExistencias.Tables("TLosProductos"), "Producto")
        ' Enlacamos el campo "Producto" de los registros de "TLosProductos" a la propiedad "Text" de la TextBox "TProducto"

        TIdentificador.DataBindings.Add("Text", MisExistencias.Tables("TLosProductos"), "Identificador")  ' Algunos componentes no tienen DataSource

        TIdentificador.ReadOnly = True                                 ' No modificación manual del Identificador
        TProducto.DataBindings.Add("Text", MisExistencias.Tables("TLosProductos"), "Producto")
        TTipo.DataBindings.Add("Text", MisExistencias.Tables("TLosProductos"), "Tipo")
        TReferencia.DataBindings.Add("Text", MisExistencias.Tables("TLosProductos"), "Referencia")
        TImagen.DataBindings.Add("Text", MisExistencias.Tables("TLosProductos"), "Imagen")
        TActualizacion.DataBindings.Add("Text", MisExistencias.Tables("TLosProductos"), "Actualizacion")
        TCantidad.DataBindings.Add("Text", MisExistencias.Tables("TLosProductos"), "Cantidad")

    End Sub

    ' El bloque de gestión de los tratamientos. Un solo procedimiente evento responde a 3 fuentes de Click : BAgregar,BModificar et BEliminar
    Private Sub Tratamientos_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BAgregar.Click, BModificar.Click, BEliminar.Click
        Static Idx As Integer
        LecturaIterativaPermitida = False ' ¡Estamos en la gestión del tratamiento, no vagamos por otro lado!
        Select Case sender.Name
            Case "BAgregar"
                If TestigoNuevoIdentificador Then ' Es False en la primera pasada aquí

                    If MessageBox.Show("Confirmación del añadido de : " & CR & CR & TIdentificador.Text & ", " & _
                                       TProducto.Text & ", " & TTipo.Text & ", " & TReferencia.Text & ", " & _
                                       TImagen.Text & ", " & TActualizacion.Text & ", " & TCantidad.Text & " ?", _
                                       "Confirmación", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.Yes Then
                        RegistrarAgregado(Idx) ' Si y solo si lo confirmamos! De lo contrario, ignoramos, es el andón de la tarea iniciada.
                        TestigoNuevoIdentificador = False
                    Else
                        MisExistencias.Tables("TLosProductos").Rows(MisExistencias.Tables("TLosProductos").Rows.Count - 1).Delete()
                        TestigoNuevoIdentificador = False
                        Exit Sub
                    End If
                Else
                    LiberarBindings()    '  Romper sus enlaces para permitir la modificación de los datos modifications manuales de datos
                    Idx = CrearIdentificador()  'El identificador se crea en la primera pasada aquí
                    TestigoNuevoIdentificador = True ' Desde que se crea el identificador ...
                    TIdentificador.Text = Idx ' Actualizar TIdentificador
                    TActualizacion.Text = Now().ToShortDateString ' Actualizar  TActualizar 
                    MisExistencias.Tables("TLosProductos").Rows.Add(TIdentificador.Text, "", "", "", "", TActualizacion.Text, 0) 'Agregar un registro vacio en el DatSet
                    MostrarDatos() ' Rehacer enlaces de datos a componentes visuales y aparece el registro vacío
                    With Me.BindingContext(MisExistencias.Tables("TLosProductos"))
                        .Position = .Count  ' Forzar la lectura del último registro, el que está vacío.
                    End With                ' Esta cusa la actualizacion de toda la pantalla ya que todos los componentes están enlacados a la misma fuente
                    TProducto.Select()      ' El focus en TArticle para que el usuario comience a codificar
                    Exit Sub                ' Salimos por la puerta "trasera" para no ejecutar el Reset del DataSet.
                End If                      ' Esta Reset del DataSet se ejecutará después de la confirmación del añadido.
            Case "BModificar"
                If TestigoNuevoIdentificador Then Exit Sub ' Esta es agregar, asi que terminamos o nos rendimos, ¡y nada más!
                Idx = TIdentificador.Text  'El identificador es el numero del registro que será procesado por SQL en modo conectado
                If MessageBox.Show("Confirmación de modificación de : " & CR & CR & TIdentificador.Text & ", " & _
                                    TProducto.Text & ", " & TTipo.Text & ", " & TReferencia.Text & ", " & _
                                    TImagen.Text & ", " & TActualizacion.Text & ", " & TCantidad.Text & " ?", _
                                    "Confirmación", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.Yes Then
                    RegistrarModificacion(Idx) ' Si y solo si lo confirmamos! De lo contrario, ignoramos, es el andón de la tarea iniciada.
                End If
            Case "BEliminar"
                If TestigoNuevoIdentificador Then Exit Sub ' Esta es agregar, asi que terminamos o nos rendimos, ¡y nada más!
                Idx = TIdentificador.Text 'El identificador es el numero del registro que será procesado por SQL en modo conectado
                If MessageBox.Show("Confirmación de eliminación de : " & CR & CR & TIdentificador.Text & ", " & _
                    TProducto.Text & " ?", "Confirmación", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.Yes Then
                    RegistrarEliminacion(Idx) ' Si y solo si lo confirmamos! De lo contrario, ignoramos, es el andón de la tarea iniciada.
                End If
        End Select
        LecturaIterativaPermitida = True ' Si llegamos aquí, es porque hemos terminado o abandonado la tarea iniciada, podemos volver a "vagar".
        LiberarBindings()   ' Romper sus enlaces para permitir la renovación de los datos
        MisExistencias.Reset()   ' Vaciar el DB en la memoria
        CargarDatos()    ' Llenar el DB en la memoria
        MostrarDatos()   ' Rehacer enlaces de datos a componentes visuales
    End Sub

    Private Sub LiberarBindings()
        For Each C As Control In Me.Controls()  ' Vistar todos los controles para encontrar 
            Try                                 ' y romper sus enlaces en un Try porque
                C.DataBindings.Clear()          ' todos, como botones, no tienen ninguno.
            Catch
            End Try
        Next
    End Sub

    Private Sub RegistrarEliminacion(ByVal IdentificadorDestino As Integer) 'Modo conectado : ejecucion sentencia SQL
        Dim ConexionTMP As OleDbConnection = Nothing
        Dim MiComando As OleDbCommand = Nothing
        ConexionTMP = AbrirConexion(FraseDeConexion, True)
        ' Solo el campo Identificador es util
        MiComando = CrearComando(MiConexion, "DELETE FROM TLosProductos" & " WHERE (Identificador = " & IdentificadorDestino.ToString & ")")
        ' Puede haber rechazo ...
        Try
            If MiComando.ExecuteNonQuery() < 1 Then
                Throw New Exception("Identificador no buscado")
            End If
        Catch Ex As Exception
            MessageBox.Show(Ex.Message & CR & "Eliminación negada" & CR & "Tablas recargadas")
        Finally
            MisExistencias.AcceptChanges()
        End Try
        ConexionTMP.Close()
    End Sub

    Private Sub RegistrarModificacion(ByVal IdentificadorDestino As Integer) 'Modo conectado : ejecucion sentencia Sql
        Dim ConexionTMP As OleDbConnection = Nothing
        Dim MiComando As OleDbCommand = Nothing
        Dim FraseSQL As String
        Dim Imagen As String
        Imagen = TImagen.Text.Replace("\", "\\") ' Porque \ a veces es una carácter de escape, especialmente para MySql, tienes que duplicar.
        ' Los campos : Identificador, Producto, Tipo, Referencia, Imagen, Actualizacion, Cantidad
        FraseSQL = "UPDATE TLosProductos SET Producto = '" _
            & TProducto.Text & "', Tipo = '" & TTipo.Text & "', Referencia = '" _
            & TReferencia.Text & "', Imagen = '" & Imagen & "', Actualizacion = '" & TActualizacion.Text & "', Cantidad = '" _
            & TCantidad.Text & "' WHERE (Identificador = " & IdentificadorDestino.ToString & ")"
        ConexionTMP = AbrirConexion(FraseDeConexion, True)
        MiComando = CrearComando(ConexionTMP, FraseSQL)
        ' Puede haber rechazo ...
        Try
            If MiComando.ExecuteNonQuery() < 1 Then
                Throw New Exception("Identificador no buscado")
            End If
        Catch Ex As Exception
            MessageBox.Show(Ex.Message & CR & "Modificación negada" & CR & "Tablas recargadas")
        Finally
            MisExistencias.AcceptChanges()
        End Try
        ConexionTMP.Close()
    End Sub

    Private Sub RegistrarAgregado(ByVal IdentificadorDestino As Integer) 'Modo conectado : ejecucion sentencia Sql
        Dim ConexionTMP As OleDbConnection = Nothing
        Dim MiComando As OleDbCommand = Nothing
        Dim FraseSQL As String
        Dim Imagen As String
        Imagen = TImagen.Text.Replace("\", "\\") ' Porque \ a veces es una carácter de escape, especialmente para MySql, tienes que duplicar.
        ' Los campos : Identificador, Producto, Tipo, Referencia, Imagen, Actualizacion, Cantidad
        FraseSQL = "INSERT INTO TLosProductos (Identificador, Producto, Tipo, Referencia, Imagen, Actualizacion, Cantidad) " &
           "VALUES ('" & IdentificadorDestino & "', '" & TProducto.Text & "', '" & TTipo.Text & "', '" &
                TReferencia.Text & "', '" & Imagen & "', '" & TActualizacion.Text & "', '" & TCantidad.Text & "' )"
        ConexionTMP = AbrirConexion(FraseDeConexion, True)
        MiComando = CrearComando(ConexionTMP, FraseSQL)
        ' Puede haber rechazo ...
        Try
            If MiComando.ExecuteNonQuery() < 1 Then
                Throw New Exception("Identificator no permitido")
            End If
        Catch Ex As Exception
            MessageBox.Show(Ex.Message & CR & "Agregado negado" & CR & "Tablas recargadas")
        Finally
            MisExistencias.AcceptChanges()
        End Try
        ConexionTMP.Close()
    End Sub

    ' El bloque de gestión de lectura. Un solo procedimiente evento responde a 4 fuentes de Click : BPrimero, BAnterior, BSiguiente y BUltimo
    Private Sub LecturaCircular_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BUltimo.Click, BAnterior.Click, BSiguiente.Click, BPrimero.Click
        ' No es necesario intentar un movimiento si el DataSet no contiene ninguna tabla.
        If MisExistencias.Tables.Count > 0 And LecturaIterativaPermitida Then
            ' El BindingContext pertenece a un contenedor, el formulario en este caso.
            With Me.BindingContext(MisExistencias.Tables("TLosProductos"))
                ' Modificacion de la propiedad Position segun el boton seleccionado.
                Select Case sender.Name
                    Case "BPrimero"
                        .Position = 0
                    Case "BAnterior"
                        If .Position = 0 Then
                            .Position = .Count - 1              ' Lectura circular (como un reloj pero al revés)
                        Else
                            .Position -= 1
                        End If
                    Case "BSiguiente"
                        If .Position = .Count - 1 Then
                            .Position = 0                       ' Lectura circular (como un reloj)
                        Else
                            .Position += 1
                        End If
                    Case "BUltimo"
                        .Position = .Count - 1
                End Select
            End With
        End If
    End Sub

    Private Sub BCargarImagen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BCargarImagen.Click
        Dim BuscarImagen As New OpenFileDialog
        Dim Resultat As DialogResult        ' Valor devueldo por el metodo Showdialog
        BuscarImagen.Title = "Designar la imagen a cargar"
        BuscarImagen.Filter = "Todos|*.*|JPEG|*.jpg|BMP|*.bmp|PNG|*.png"
        BuscarImagen.CheckFileExists = False
        Resultat = BuscarImagen.ShowDialog()
        If Resultat = Windows.Forms.DialogResult.OK Then ' OK es la prueba de un dato plausible
            TImagen.Text = BuscarImagen.FileName
        End If
        BuscarImagen.Dispose()
    End Sub

    ' Cargar el imagen necesaria para cada registro
    Private Sub TImagen_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TImagen.TextChanged
        If TImagen.Text <> String.Empty Then
            Dim Imagen As String
            Imagen = TImagen.Text.Replace("\\", "\")  ' Porque si \ no es un carácter de escape, tienes que eliminar el duplicado.
            PBImagen.Image = System.Drawing.Image.FromFile(Imagen)
            PBImagen.SizeMode = PictureBoxSizeMode.StretchImage
        Else
            PBImagen.Image = Nothing
        End If
    End Sub

End Class


